/*
 * News Maker version1.00
 * Copyright (c) F؁@T 1995
 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <ctype.h>
#include <time.h>

#define esc 0x1b

#define credit "News Maker version 1.00 \nCopyright (c) F؁@T 1995\n"
#define usage "news <f[^t@C> [<Ot@C>]\n"

FILE *fp1;	/* f[^t@C̃t@C|C^ */
FILE *fp2;	/* Ot@C̃t@C|C^ */

static unsigned char stream[100][100];	/* f[^ */
static unsigned char howmanyx;			/* f[^s邩 */
static unsigned char howmanyy[100];		/* f[^悎s̗vf̐ */
static char *block[100][100];			/* xۯys̕ւ߲ */
static unsigned char howmanybx;			/* ubN̐ */
static unsigned char howmanyby[100];	/* nubN̗vf̐ */
static unsigned char title[256];		/* f[^̃^Cg */
static unsigned char buffer[256];		/* i[p */
static unsigned char wt;				/* Ot@C邩ǂ */

/* f[^t@C̃I[v */
void readopen(char *filename)
	{
	if(NULL==(fp1=fopen(filename,"r")))
		{
		fprintf(stderr,"t@C܂\n");
		exit(1);
		}
	}

/* o̓t@C̃I[v */
void writeopen(char *filename)
	{
	if(NULL==(fp2=fopen(filename,"w")))
		{
		fprintf(stderr,"t@C̃I[vɎs܂\n");
		exit(1);
		}
	}

/* t@C */
void fileclose(void)
	{
	fclose(fp1);
	if(wt==1)
		{
		fclose(fp2);
		}
	}

/* ėpG[ */
void error(void)
	{
	fprintf(stderr,"t@CG[܂\n");
	fileclose();
	exit(1);
	}

/* t@CPsǂݍ */
unsigned char getline(void)
	{
	if(NULL==fgets(buffer,256,fp1))
		{
		return 1;
		}

	while(buffer[0]==';' || buffer[0]=='\n')
		{
		if(NULL==fgets(buffer,256,fp1))
			{
			return 1;
			}
		}
	return 0;
	}

/* ^Cgf[^ǂݍ */
void gettitle(void)
	{
	if(getline()==1)
		{
		error();
		}
	strcpy(title,buffer);
	}

/* f[^̃`FbN */
void checkbuf(void)
	{
	unsigned char c;

	for(c=0;c<strlen(buffer);++c)
		{
		if(isdigit(buffer[c])==0 && buffer[c]!='-'
			&& buffer[c]!=',' && buffer[c]!='\n')
			{
			fprintf(stderr,
					"\nf[^̒ɐA-A,ȊO̕܂\n");
			fileclose();
			exit(1);
			}
		}
	}

/* f[^ǂݍ */
void getstream(void)
	{
	signed int a;
	char *b;
	unsigned char x,y,counter;
	a=0;x=0;y=0,counter=0;

	if(getline()==1)
		{
		error();
		}
	checkbuf();

	b=strtok(buffer,",");
	a=atoi(b);
	for(;;)
		{
		if(a>=0)
			{
			stream[x][counter]=(char)a;
			counter++;
			if(counter>100)
				{
				fprintf(stderr,"f[^Psɗvf100܂łł\n");
				fileclose();
				exit(1);
				}
			}

		if(a==-1)
			{
			counter--;
			howmanyy[x]=counter;
			howmanyx=x;
			return;
			}

		if(a==-2)
			{
			counter--;
			howmanyy[x]=counter;
			x++;
			if(x==100)
				{
				fprintf(stderr,"f[^100s܂łł\n");
				fileclose();
				exit(1);
				}
			counter=0;
			if(getline()==1)
				{
				error();
				}
			checkbuf();
			b=strtok(buffer,",");
			a=atoi(b);
			}
		else
			{
			b=strtok(NULL,",");
			a=atoi(b);
			}
		}
	}

/* ̓f[^ǂݍ */
void getblock(void)
	{
	unsigned char a,b,x,y;
	x=0;y=0;

	for(;;)
		{
		if(getline()==1)
			{
			error();
			}
		if(strcmp(buffer,"/E\n")==0 || strcmp(buffer,"/e\n")==0)
			{
			y--;
			howmanyby[x]=y;
			x++;
			y=0;
			if(getline()==1)
				{
				x--;
				howmanybx=x;
				return;
				}
			}

		for(a=0;a<strlen(buffer);++a)
			{
			if(buffer[a]=='\n')
				{
				buffer[a]='\0';
				}
			}

		for(a=0;a<strlen(buffer);++a)
			{
			if(buffer[a]=='/' && buffer[a+1]=='@')
				{
				buffer[a]='\n';
				for(b=a+1;b<strlen(buffer);++b)
					{
					buffer[b]=buffer[b+1];
					}
				}
			}

		if(x==100)
			{
			fprintf(stderr,"̓f[^100ubN܂łł\n");
			fileclose();
			exit(1);
			}

		if(y==100)
			{
			fprintf(stderr,"̓f[^͂PubN100s܂łł\n");
			fileclose();
			exit(1);
			}

		block[x][y]=strdup(buffer);
		if(block[x][y]==NULL)
			{
			fprintf(stderr,"܂\n");
			fileclose();
			exit(1);
			}
		y++;
		}
	}

/* 𔭐 */
unsigned char random()
	{
	unsigned char r;

	r=(char)rand() & 127;
	return r;
	}

/* ͂\iCj */
void putnews(void)
	{
	unsigned char a;	/* f[^̂ǂ̗g */
	unsigned char b;	/* eubN̉Ԗڂ̗vfg */
	unsigned char x;	/* af[^̑xԖ */

	printf("%s\n",title);
	if(wt==1)
		{
		if(fputs(title,fp2))
			{
			error();
			}
		if(fputs("\n",fp2))
			{
			error();
			}
		}

	srand((unsigned int)clock());

	for(;;)
		{
		/* ǂ̗f[^g߂ */
		a=random();
		while(a>howmanyx)
			{
			a=random();
			}

		for(x=0;x<=howmanyy[a];++x)
			{
			b=random();
			if(stream[a][x]>howmanybx)
				{
				fprintf(stderr,"\n\n`ĂȂubN%dAf[^"
								"%dsڂ̑%dڂŎw肳܂\n"
								,stream[a][x],a+1,x+1);
				fileclose();
				exit(1);
				}

			while(b>howmanyby[stream[a][x]])
				{
				b=random();
				}
			printf("%s",block[stream[a][x]][b]);
			if(wt==1)
				{
				if(fputs(block[stream[a][x]][b],fp2))
					{
					error();
					}
				}
			}
		printf("\n\n");
		if(wt==1)
			{
			if(fputs("\n\n",fp2))
				{
				error();
				}
			}
		if(getch()==esc)
			{
			fileclose();
			exit(0);
			}
		}
	}

/* X^[gAbv */
main(int argc,char *argv[])
	{
	if(argc<2)
		{
		printf(credit"gp@F"usage);
		exit(0);
		}

	printf(credit"\n");

	printf("f[^t@CI[v܂\n");
	readopen(argv[1]);
	printf("f[^t@C̃I[vɐ܂\n\n");

	if(argc>2)
		{
		printf("Ot@CI[v܂\n");
		wt=0;
		writeopen(argv[2]);
		wt=1;
		printf("Ot@C̃I[vɐ܂\n\n");
		}

	printf("^Cgǂݍł܂\n");
	gettitle();
	printf("^Cg̓ǂݍ݂I܂\n\n");

	printf("f[^ǂݍł܂\n");
	getstream();
	printf("f[^̓ǂݍ݂I܂\n\n");

	printf("̗͂vfǂݍł܂\n");
	getblock();
	printf("̗͂vf̓ǂݍ݂I܂\n\n\n");

	putnews();
	}
